/*!
 * © 2022 David Vines
 *
 * domainOfTheAncients is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * any later version.
 *
 * domainOfTheAncients is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with domainOfTheAncients. If not, see https://www.gnu.org/licenses/gpl-2.0.html.
 */
/* exported HoldPositionShipOrder, HoldAndColoniseShipOrder, JumpShipOrder, JumpToAndColonisePlanetShipOrder, ShipOrder */
class HoldPositionShipOrder {
	constructor() {
	}
	toJSON() { return "HoldPos"; }
	toString() { return "Hold Position"; }
}
HoldPositionShipOrder.SINGLETON = new HoldPositionShipOrder();

class HoldAndColoniseShipOrder {
	constructor() {
	}
	toJSON() { return "HoldCol"; }
	toString() { return "Hold Position and attempt to colonise"; }
}
HoldAndColoniseShipOrder.SINGLETON = new HoldAndColoniseShipOrder();

class JumpShipOrder {
	constructor(target) {
		this._target = target;
	}
	get target() { return this._target; }
	toJSON() { return "JumpTo "+this._target; }
	toString() { return "Jump to "+this._target; }
}

class JumpToAndColonisePlanetShipOrder {
	constructor(target) {
		this._target = target;
	}
	get target() { return this._target; }
	toJSON() { return "Coloni "+this._target; }
	toString() { return "Jump to "+this._target+" and attempt to colonise it"; }
}

let ShipOrder = {
	fromJSON: function(json) {
		if (json.slice(0,7) == "HoldPos") return HoldPositionShipOrder.SINGLETON;
		if (json.slice(0,7) == "HoldCol") return HoldAndColoniseShipOrder.SINGLETON;
		if (json.slice(0,7) == "JumpTo ") return new JumpShipOrder(json.slice(7));
		if (json.slice(0,7) == "Coloni ") return new JumpToAndColonisePlanetShipOrder(json.slice(7));
		return undefined;
	}
};